## START: Set by rpmautospec
## (rpmautospec version 0.7.2)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global         commit      f66a661359a39e10af01508ad02429517b8460e3
%global         shortcommit  %(c=%{commit}; echo ${c:0:8})

Name:           cproc
Version:        0.0^20240428.f66a6613
Release:        %{autorelease}
Summary:        A C11 compiler using QBE as a backend

License:        ISC AND MIT AND Unlicense
URL:            https://git.sr.ht/~mcf/cproc/
Source:         %{url}/archive/%{commit}.tar.gz
Patch:          redhat-linux-configure.patch
# Compiler has not been ported to other architectures
ExclusiveArch:  aarch64 riscv64 x86_64

BuildRequires:  gcc
BuildRequires:  glibc-devel
BuildRequires:  make
BuildRequires:  qbe

%description
cproc is a C11 compiler using QBE as a backend. It is released under the ISC
license.

Some C23 features and GNU C extensions are also implemented.

There is still much to do, but it currently implements most of the language and
is capable of building software including itself, mcpp, gcc 4.7, binutils, and
more.

It was inspired by several other small C compilers including 8cc, c, lacc, and
scc.

%prep
%autosetup -n %{name}-%{commit} -p 1


%build
# Fedora specific commands not used
./configure
%make_build all

%install
mkdir -p %{buildroot}%{_bindir}
install -m 755 cproc %{buildroot}%{_bindir}
install -m 755 cproc-qbe %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man1
install -m 644 cproc.1 %{buildroot}%{_mandir}/man1/

%check
make check

%files
%license LICENSE
%doc README.md
%doc doc/*.md
%{_bindir}/cproc
%{_bindir}/cproc-qbe
%{_mandir}/man1/cproc.1*


%changelog
## START: Generated by rpmautospec
* Mon Nov 11 2024 John Doe <packager@example.com> - 0.0^20240428.f66a6613-1
- Uncommitted changes
## END: Generated by rpmautospec
